<?php 
/* 
Plugin Name: Image-in-Post
Version: 0.2
Plugin URI: 
Description: Automatically inserts a picture and caption into a post using a custom tag &lt;pic&gt;&lt;/pic&gt;
Author: Ali Hassan 
Author URI: http://www.ali-hassan.net
*/ 

function picinpost($data) {

//Let's set all the variables here at the start to keep things simple to edit

	// set the tag that will be used to identify where the picture info is
	$tag ="pic";

	// set url at which the images are located -- this is where the pictures should be located
	$imgurl = get_settings('fileupload_url').'/';	

	//set the path to the images
	$imgpath = "/images".'/';

	//the string that will indicate where the caption begins
	$captionIndicator = "?cap=";

	//the html code which will be used to put a div element around the picture and its caption
	$divstart = '<div class="pic">';
	$divend = '</div>';

	//the html code that will be put around the caption
	$captagstart = '<p>';
	$captagend = '</p>';



	// determine what the target window shouold be: _new opens in a new window
	$target ="_new";



//Stuff down here shouldn't need to be changed too much

// extract the image name and the caption (if present from the

	$taglength =strlen($tag);

	//These lines convert the single quotes back to single quotes so that php can read them properly
	$data = str_replace("&#8216;","'",$data);
	$data = str_replace("&#8217;","'",$data);

	//And this does it for the double quotes
	$data = str_replace('&#8220;','"',$data);
	$data = str_replace('&#8221;','"',$data);

	while($tagstart = strpos($data, "<".$tag.">")) { 
		$tagend = strpos($data, "</".$tag.">"); 
		$tagtrueend = $tagend + $taglenth + 3 + $taglength; 
		$before = substr($data, 0, $tagstart); 
		$after = substr($data, $tagtrueend); 
		$tagcodelength = $tagend - ($tagstart+2+$taglength); 
		$pictag = substr($data, $tagstart+2+$taglength, $tagcodelength); 




	//locate the beginning and the end of the caption within $pictag
	$captionstart = strpos($pictag, $captionIndicator);
	$captionend = strlen($pictag);

	//now extract the caption from $pictag, or if none exists, set it to NONE
	if ($captionstart == "") {	
		
			$caption = "NONE";
		} else 
		{		
			$caption = substr($pictag, $captionstart+5, $captionend);
		};

	//extract the image filename from $pictag
	if ($captionstart =="") {
		$imageFilename = $pictag;
		} else 
		{
			$imageFilename = substr($pictag, 0 , $captionstart);
		};


//Now generate the html code to insert into the page



	// this is the code to generate the img tag
	$dq ='"';
	$all = "<img src=$dq$imgpath$imageFilename$dq alt=$dq$caption$dq></img>";
	
	//and this is the code for the caption
	$captioncode = $captagstart.$caption.$captagend;


	ob_start(); 
	
	//begin the div
	echo($divstart);

	//insert the image code, surrounded by a link
		echo($all);

	//put the caption in if there is one
		if ($caption != "NONE") {
		echo($captioncode);
		};

	//close the div
	echo($divend);



	$data = $before.ob_get_clean().$after; 


	}
	return $data;

	};

add_filter ('the_content','picinpost')
?>
