<?php 
/* 
Plugin Name: Thumb-in-Post
Version: 0.2 
Plugin URI: 
Description: Automatically inserts a thumbnail and caption into a post using a custom tag &lt;thumb&gt;&lt;/thumb&gt;
Author: Ali Hassan 
Author URI: http://www.ali-hassan.net
*/ 

function thumbinpost($data) {

//Let's set all the variables here at the start to keep things simple to edit

	// set the tag that will be used to identify where the picture info is
	$tag ="thumb";

	// set url at which the images are located -- this is where the pictures should be located
	$imgurl = get_settings('fileupload_url').'/';	

	//set the path to the images
	$imgpath = "images".'/';

	//subdirectory of the $imgpath in which the thumbnails will be stored
	$thumbpath = $imgpath.'t/';
	
	//the string that will indicate where the caption begins
	$captionIndicator = "?cap=";

	//the html code which will be used to put a div element around the picture and its caption
	$divstart = '<div class="thumb">';
	$divend = '</div>';

	//the html code that will be put around the caption
	$captagstart = '<p>';
	$captagend = '</p>';

	//set the width of the thumbnail
	$img_out_width = 400;

	//set the jpeg quality of the thumbnail -- 0 is worst; 100 is best
	$jpegQuality = 60;

	//the prefix which will be added to the filename when the thumbnail is generated
	$thumbprefix = "tn_";

	// determine what the target window shouold be: _new opens in a new window
	$target ="_new";

	//the text that you want to have appear indicating that the picture can be enlarged
	$enlarge = '<img src="/images/Magnify.gif" alt="Enlarge"></img>';



//Stuff down here shouldn't need to be changed too much

// extract the image name and the caption (if present from the

	$taglength =strlen($tag);

	//These lines convert the single quotes back to single quotes so that php can read them properly
	$data = str_replace("&#8216;","'",$data);
	$data = str_replace("&#8217;","'",$data);

	//And this does it for the double quotes
	$data = str_replace('&#8220;','"',$data);
	$data = str_replace('&#8221;','"',$data);

	while($tagstart = strpos($data, "<".$tag.">")) { 
		$tagend = strpos($data, "</".$tag.">"); 
		$tagtrueend = $tagend + $taglenth + 3 + $taglength; 
		$before = substr($data, 0, $tagstart); 
		$after = substr($data, $tagtrueend); 
		$tagcodelength = $tagend - ($tagstart+2+$taglength); 
		$pictag = substr($data, $tagstart+2+$taglength, $tagcodelength); 




	//locate the beginning and the end of the caption within $pictag
	$captionstart = strpos($pictag, $captionIndicator);
	$captionend = strlen($pictag);

	//now extract the caption from $pictag, or if none exists, set it to NONE
	if ($captionstart == "") {	
		
			$caption = "NONE";
		} else 
		{		
			$caption = substr($pictag, $captionstart+5, $captionend);
		};

	//extract the image filename from $pictag
	if ($captionstart =="") {
		$imageFilename = $pictag;
		} else 
		{
			$imageFilename = substr($pictag, 0 , $captionstart);
		};




//This is where the image resize stuff starts

//If a thumbnail already exists then don't bother generating a new one	
if (!file_exists($thumbpath.$thumbprefix.$imageFilename)) {

	// retrieve file info -- check to see what file type it is
	$imginfo = getimagesize($imgpath.$imageFilename);

	// load the image from file into a variable called $img_in
	switch ($imginfo[2]) { 

		case 2:		// jpg
			$img_in = imagecreatefromjpeg($imgpath.$imageFilename);
      			break;

		case 3:		// png
			$img_in = imagecreatefrompng($imgpath.$imageFilename);
			break;

		default:
			echo('Error: cannot resize images other than JPEG or PNG; or file not found');
	};


	// figure out what the height of the output image should be in order to maintain the proper aspect ratio
	$img_ratio = $imginfo[1]/$imginfo[0];
	$img_out_height = $img_ratio*$img_out_width;

	// create a new image in $img_out with the dimensions $img_out_width and $img_out_height
	$img_out = imagecreatetruecolor($img_out_width, $img_out_height);

	// now copy $img_in into $img_out
	imagecopyresampled($img_out,$img_in,0,0,0,0,imagesx($img_out),imagesy($img_out),imagesx($img_in),imagesy($img_in));

	// write the image into a file in the thumbnail directory
	switch ($imginfo[2]) {

		case 2:		// jpg
			imagejpeg($img_out, $thumbpath.$thumbprefix.$imageFilename, $jpegQuality);
			break;

		case 3:		// png
			imagepng($img_out, $thumbpath.$thumbprefix.$imageFilename);
			break;

		default: 
			echo('Error: could not write image');
	};
	
	} // end the else statement


//Image resize ends


//Now generate the html code to insert into the page

	$dq ='"';

	//code to build links to the full size image
	$linkstart = "<a href=$dq$imgpath$imageFilename$dq target=$dq$target$dq>";
	$linkend = "</a>";

	// this is the code to generate the img tag
	$all = "<img src=$dq$thumbpath$thumbprefix$imageFilename$dq alt=$dq$caption$dq></img>";
	
	//and this is the code for the caption
	$captioncode = $captagstart.$linkstart.$enlarge.$linkend.$caption.$captagend;


	ob_start(); 
	
	//begin the div
	echo($divstart);

	//insert the image code, surrounded by a link
	echo($linkstart);
		echo($all);
	echo($linkend);
	//
	
	if ($caption != "NONE") {
		echo($captioncode);
		};
	echo($divend);
	$data = $before.ob_get_clean().$after; 


	}
	return $data;

	};

add_filter ('the_content','thumbinpost')
?>
